# SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
##########################################################################
#
# This file is provided under a dual license.  When you use or
# distribute this software, you may choose to be licensed under
# version 2.1 of the GNU Lesser General Public License
# ("LGPLv2.1 License") or BSD License.
#
# LGPLv2.1 License
#
# Copyright(C) 2019 MediaTek Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2.1 of the GNU Lesser General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
# details.
#
# BSD LICENSE
#
# Copyright(C) 2019 MediaTek Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
###########################################################################

ifndef PRJ_ROOT
	ifdef KERNEL_DRV_ROOT
		ifdef O
			DRV_SRC_ROOT =../../
		endif
	else
		DRV_SRC_ROOT =
	endif
	export PRJ_ROOT =$(DRV_SRC_ROOT)drivers/mtk/mt5891
endif

ifndef LINUX_DRV_ROOT
export LINUX_DRV_ROOT = $(PRJ_ROOT)
endif

ifndef DRV_ROOT
export DRV_ROOT = $(PRJ_ROOT)
endif

TARGET_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)
TARGET_INC = -I$(TARGET_ROOT)/private_inc	\
		     -I$(TARGET_ROOT)/drv_inc		\
		     -I$(TARGET_ROOT)/inc           \
		     -I$(TARGET_ROOT)/psr           \
		     -I$(TARGET_ROOT)/drv_cust      \
             -I$(TARGET_ROOT)/brdcst_if/tuner_src/inc                   \
             -I$(TARGET_ROOT)/b2r8391                                       \
             -I$(TARGET_ROOT)/playmgr                                   \
             -I$(TARGET_ROOT)/jpg                                       \
			 -I$(TARGET_ROOT)/image/jpg_6896/                                      \
             -I$(TARGET_ROOT)/bsp                                       \
             -I$(TARGET_ROOT)/pcmcia                                    \
             -I$(TARGET_ROOT)/pcmcia/CableCard                          \
             -I$(TARGET_ROOT)/brdcst_if/tuner_src/TunerATD/eu           \
             -I$(TARGET_ROOT)/brdcst_if/tuner_src/TunerATD/na           \
             -I$(TARGET_ROOT)/brdcst_if/brdcst_if/tuner_src/TunerATD/na \
             -I$(TARGET_ROOT)/usb/include                               \
             -I$(TARGET_ROOT)/usb/include/class                         \
             -I$(TARGET_ROOT)/usb/src/cd                                \
             -I$(TARGET_ROOT)/usb/src/drivers                           \
             -I$(TARGET_ROOT)/usb/src/drivers/aud                       \
             -I$(TARGET_ROOT)/usb/src/drivers/bluetooth                 \
             -I$(TARGET_ROOT)/usb/src/drivers/hid                       \
             -I$(TARGET_ROOT)/usb/src/drivers/hub                       \
             -I$(TARGET_ROOT)/usb/src/drivers/msd                       \
             -I$(TARGET_ROOT)/usb/src/drivers/sicd                      \
             -I$(TARGET_ROOT)/usb/src/drivers/trans                     \
             -I$(TARGET_ROOT)/usb/src/functions/trans_fn                \
             -I$(TARGET_ROOT)/usb/src                                   \
             -I$(TARGET_ROOT)/usb/src/systems/none/afs                  \
             -I$(TARGET_ROOT)/usb/src/systems/none                      \
             -I$(TARGET_ROOT)/usb/src/systems/ucos						\
             -I$(TARGET_ROOT)/venc										\
             -I$(TARGET_ROOT)/venc/h264									\
             -I$(TARGET_ROOT)/osd6896   \
             -I$(TARGET_ROOT)/dmx8290
TARGET_INC += -I$(VM_LINUX_ROOT)/project_x/middleware/public/res_mngr/drv
TARGET_INC += -I$(VM_LINUX_ROOT)/project_x/middleware/public/res_mngr
TARGET_INC += -I$(VM_LINUX_ROOT)/project_x/middleware/public
TARGET_INC += -I$(VM_LINUX_ROOT)/linux_core/app_if/mtal/mtal_inc
TARGET_INC += -I$(VM_LINUX_ROOT)/project_x/target/public/mt53xx_com/mw_if2
TARGET_INC += -I$(X_INC_DIR)
ifdef DRV_INC_DIR
TARGET_INC += -I$(DRV_INC_DIR)
endif
AUD_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/aud2
AUD_INC = -I$(AUD_ROOT)/include             \
          -I$(AUD_ROOT)/adsp                \
          -I$(AUD_ROOT)/adsp/include        \
          -I$(AUD_ROOT)/adsp/include_API    \
          -I$(AUD_ROOT)/audio \
          -I$(AUD_ROOT)/periph

D_CUST_INC = -I$(DRV_ROOT)/../d_inc         \
             -I$(DRV_ROOT)/d_inc

ifeq "$(OSAI_VER)" "2"
OSAI_ROOT = osai_v2
else
OSAI_ROOT = osai
endif

LINUX_ROOT = $(DRV_ROOT)/linux
LINUX_INC = -Iinclude/asm/arch/inc          \
            -I$(LINUX_ROOT)/include         \
            -I$(LINUX_ROOT)/$(OSAI_ROOT)/inc        \
		    -I$(LINUX_ROOT)/lib/mw	\
		    -I$(LINUX_ROOT)/lib/mw/x_inc	\
		    -I$(LINUX_ROOT)/lib/mw/inc \
		    -I$(LINUX_ROOT)/app_if/mtal     \
		    -I$(LINUX_ROOT)/include/linux   \
		    -I$(LINUX_ROOT)/cb

PLAYMGR_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/playmgr_v2
PLAYMGR_INC = -I$(PLAYMGR_ROOT)

SWDMX_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/swdmx_v2
SWDMX_INC = -I$(SWDMX_ROOT)

DMX_ROOT =  $(DRV_ROOT)/$(DRIVER_DIR)/dmx8290
DMX_INC = -I$(DMX_ROOT) -I$(DMX_ROOT)/include -I$(DMX_ROOT)/gcpu/iram -I$(DMX_ROOT)/cypher/aes -I$(DMX_ROOT)/drm/mtk_skb_driver/ -I$(DMX_ROOT)/drm/libtomcrypt-1.16/src/headers -I$(DMX_ROOT)/drm/libtommath-0.41

TZ_ROOT = $(VM_LINUX_ROOT)/target/public/mt53xx_com/tz_secure
TZ_INC = -I$(TZ_ROOT)/open/inc/skb -I$(TZ_ROOT)/open/inc/hci

VDEC_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/vdec_v2
VDEC_INC = -I$(VDEC_ROOT) \
           -I$(VDEC_ROOT)/h264 \
           -I$(VDEC_ROOT)/mpeg4 \
           -I$(VDEC_ROOT)/mpv \
           -I$(VDEC_ROOT)/wmv \
           -I$(VDEC_ROOT)/img \
           -I$(VDEC_ROOT)/rv \
           -I$(VDEC_ROOT)/avs \
           -I$(VDEC_ROOT)/vp6 \
           -I$(VDEC_ROOT)/vp8 \
           -I$(VDEC_ROOT)/raw

TUNER_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/brdcst_if/tuner_src
TUNER_INC = -I$(TUNER_ROOT)/Tuner \
            -I$(TUNER_ROOT)/TunerHAL \
            -I$(TUNER_ROOT)/CtrlBus \
            -I$(TUNER_ROOT)/TunerPool \
            -I$(TUNER_ROOT)/TunerNptv/system \
            -I$(TUNER_ROOT)/inc

ifeq "$(findstring 5890_MT5112EE,$(BRDCST_IF))" "5890_MT5112EE"
TUNER_INC += -I$(TUNER_ROOT)/TunerDTD
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogNA
DEFINES += -DCC_FEDTD
endif
ifeq "$(findstring 5890_MT5135,$(BRDCST_IF))" "5890_MT5135"
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBC
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogEU
DEFINES += -DCC_FEDVBT
DEFINES += -DCC_DVBT_SUPPORT
endif
ifeq "$(findstring 5890DUAL,$(BRDCST_IF))" "5890DUAL"
TUNER_INC += -I$(TUNER_ROOT)/TunerDTD
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogNA
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogEU
DEFINES += -DCC_DVBT_SUPPORT
endif

ifeq "$(findstring 5890DVBTC,$(BRDCST_IF))" "5890DVBTC"
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBC
DEFINES += -DCC_DVBT_SUPPORT
endif

ifeq "$(findstring TC90517,$(BRDCST_IF))" "TC90517"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/TC90517
endif

#$(error DRV_ROOT is $(DRV_ROOT))
ifeq "$(findstring VDRISDBT,$(BRDCST_IF))" "VDRISDBT"
TUNER_INC += -I$(DRV_ROOT)/3rd_party/LINUX/VDRBRDCST/VDRDemod/TC90527
endif

ifeq "$(findstring MN88471,$(BRDCST_IF))" "MN88471"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/MN88471/
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
endif

ifeq "$(findstring ATBM8848,$(BRDCST_IF))" "ATBM8848"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/ATBM8848
endif

ifeq "$(findstring ATBM8846E,$(BRDCST_IF))" "ATBM8846E"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/ATBM8846E
endif

ifeq "$(findstring CXD2820,$(BRDCST_IF))" "CXD2820"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/CXD2820
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
endif
ifeq "$(findstring 8G80,$(BRDCST_IF))" "8G80"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/8G80
endif
TUNER_INC += -I$(TUNER_ROOT)/TunerATD/eu
TUNER_INC += -I$(TUNER_ROOT)/TunerATD/common
TUNER_INC += -I$(TUNER_ROOT)/TunerATD/na
NPTV_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/nptv5891
NPTV_INC += -I$(NPTV_ROOT)/inc \
		  -I$(NPTV_ROOT)/inc/hw \
		  -I$(NPTV_ROOT)/inc/drv \
		  -I$(NPTV_ROOT)/inc/sys \
		  -I$(NPTV_ROOT)/drv/tuner/system \
		  -I$(NPTV_ROOT)/inc/empty \
		  -I$(NPTV_ROOT)/inc/tmp

VDP_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/vdp8290

VDP_INC += -I$(VDP_ROOT)

export DRIVER_INC = $(TARGET_INC) $(AUD_INC) $(D_CUST_INC) $(LINUX_INC) $(TUNER_INC) $(VDEC_INC) $(PLAYMGR_INC) $(SWDMX_INC) $(NPTV_INC) $(VDP_INC) $(DMX_INC) $(TZ_INC)

DEFINES += -D_CPU_LITTLE_ENDIAN_ -DCC_MT5891
ifneq "$(LINUX_SOLUTION)" "true"
DEFINES += -DCC_DRIVER_PROGRAM
DEFINES += -DDEFAULT_PANEL_SELECT=0
endif
DEFINES += -DCC_SCPOS_EN -DCC_SRM_ON
DEFINES += -DCC_53XX_SWDMX_V2
# -DDEFAULT_PANEL_SELECT=$(PANEL_SELECT)
DEFINES += -DCC_DYNAMIC_POWER_ONOFF

ifeq "$(BUILD_CFG)" "debug"
DEFINES += -g -mapcs-frame
else
DEFINES += -DNDEBUG
endif

OPTIMIZE_LVL ?= -O2
DEFINES += $(OPTIMIZE_LVL)

export DEFINES := $(sort $(DEFINES))
