# SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
##########################################################################
#
# This file is provided under a dual license.  When you use or
# distribute this software, you may choose to be licensed under
# version 2.1 of the GNU Lesser General Public License
# ("LGPLv2.1 License") or BSD License.
#
# LGPLv2.1 License
#
# Copyright(C) 2019 MediaTek Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2.1 of the GNU Lesser General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
# details.
#
# BSD LICENSE
#
# Copyright(C) 2019 MediaTek Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
###########################################################################

ifndef RLS_CUSTOM_BUILD
RLS_CUSTOM_BUILD = false
endif

LINUX_ROOT ?= $(word 1, $(subst /vm_linux/,/vm_linux /, $(shell pwd)))
export PRJ_ROOT = $(LINUX_ROOT)/linux_core

ifndef CUSTOMER_ARCH_BUILD
DRV_PATH = $(PRJ_ROOT)/driver/ko
endif
ifndef KERNEL_VER
	KERNEL_VER := linux-3.0
endif

LINUX_PATH = $(PRJ_ROOT)/kernel/$(KERNEL_VER)

export LINUX_DRV_ROOT = $(DRV_PATH)/mt5891
export DRV_ROOT = $(LINUX_DRV_ROOT)

DRV_INC = -I$(DRV_ROOT)/d_inc                   \
          -I$(DRV_ROOT)/$(DRIVER_DIR)/drv_cust    \
          -I$(DRV_ROOT)/$(DRIVER_DIR)/drv_inc     \
          -I$(DRV_ROOT)/$(DRIVER_DIR)/inc         \
          -I$(DRV_ROOT)/$(DRIVER_DIR)/private_inc \
          -I$(DRV_ROOT)/linux/lib/mw/x_inc            \
          -I$(X_INC_DIR) \
          -I$(DRV_ROOT)/linux/lib/mw/inc        \
          -I$(DRV_ROOT)/linux/osai/inc                \
          -I$(DRV_ROOT)/linux/include                \
          -I$(LINUX_PATH)/include/asm/arch/inc    \
          -I$(PRJ_ROOT)/driver/target/public/d_inc

# APP_DRV_TABLE_SHARE: start
ifndef VM_LINUX_ROOT
        VM_LINUX_ROOT := $(word 1, $(subst /vm_linux/,/vm_linux /, $(shell pwd)))
endif

SYS_BUILD_ROOT = $(VM_LINUX_ROOT)/sys_build/$(CUSTOMER)/$(MODEL_NAME)/vid
DRV_INC += -I$(SYS_BUILD_ROOT)
## APP_DRV_TABLE_SHARE: end

# APP_DRV_TABLE_SHARE
DRV_INC += -I$(SYS_BUILD_ROOT)

ifdef O
DRV_INC += -I$(O)/include/asm/arch/inc
endif

AUD_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/aud2
AUD_INC = -I$(AUD_ROOT)/include             \
          -I$(AUD_ROOT)/adsp/include        \
          -I$(AUD_ROOT)/adsp/include_API    \
          -I$(AUD_ROOT)/audio \
          -I$(AUD_ROOT)/periph \
          -I$(AUD_ROOT)/adsp

TARGET_INC = -I.					                \
            -I$(DRV_ROOT)/$(DRIVER_DIR)/private_inc	\
            -I$(DRV_ROOT)/$(DRIVER_DIR)/drv_inc		\
            -I$(DRV_ROOT)/$(DRIVER_DIR)/inc 		    \
            -I$(DRV_ROOT)/linux/lib/mw/x_inc		        \
            -I$(DRV_ROOT)/$(DRIVER_DIR)/image/jpg_6896 \
            -I$(X_INC_DIR) \
            -I$(DRV_ROOT)/linux/app_if/drvif                   \
            -I$(DRV_ROOT)/linux/cb

# MTAL_PORTING: start
ifndef VM_LINUX_ROOT
        VM_LINUX_ROOT := $(word 1, $(subst /vm_linux/,/vm_linux /, $(shell pwd)))
endif

TARGET_INC += -I$(VM_LINUX_ROOT)/middleware/public/res_mngr/drv
TARGET_INC += -I$(VM_LINUX_ROOT)/middleware/public/res_mngr
TARGET_INC += -I$(VM_LINUX_ROOT)/middleware/public
TARGET_INC += -I$(VM_LINUX_ROOT)/linux_core/app_if/mtal/mtal_inc
TARGET_INC += -I$(VM_LINUX_ROOT)/target/public/mt53xx_com/mw_if2
ifeq "$(LINUX_SLT_SUPPORT)" "true"
TARGET_INC += -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/include                               \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/include/class                         \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/cd                                \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers                           \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers/aud                       \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers/bluetooth                 \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers/hid                       \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers/hub                       \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers/msd                       \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers/sicd                      \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/drivers/trans                     \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/functions/trans_fn                \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src                                   \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/systems/none/afs                  \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/systems/none                      \
              -I$(DRV_ROOT)/$(DRIVER_DIR)/usb/src/systems/ucos
endif
# MTAL_PORTING: end

ifdef DRV_INC_DIR
TARGET_INC += -I$(DRV_INC_DIR)
endif

D_CUST_INC = -I$(DRV_ROOT)/../d_inc \
             -I$(DRV_ROOT)/d_inc

ifeq "$(OSAI_VER)" "2"
OSAI_INC = -I$(DRV_ROOT)/linux/osai_v2/inc
else
OSAI_INC = -I$(DRV_ROOT)/linux/osai/inc
endif

PSR_INC = -I$(DRV_ROOT)/$(DRIVER_DIR)/psr

PLAYMGR_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/playmgr_v2
PLAYMGR_INC = -I$(PLAYMGR_ROOT)

SWDMX_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/swdmx_v2
SWDMX_INC = -I$(SWDMX_ROOT)

DMX_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/dmx8290
DMX_INC = -I$(DMX_ROOT) -I$(DMX_ROOT)/include -I$(DMX_ROOT)/gcpu/iram -I$(DMX_ROOT)/cypher/aes -I$(DMX_ROOT)/drm/mtk_skb_driver/ -I$(DMX_ROOT)/drm/libtomcrypt-1.16/src/headers -I$(DMX_ROOT)/drm/libtommath-0.41 -I$(DMX_ROOT)/drm/mtk_hci/ -I$(DMX_ROOT)/drm/mtk_hci/nautilus_3.5_RC/ -I$(DMX_ROOT)/drm/mtk_hci/nautilus_3.5_RC/include -I$(DMX_ROOT)/drm/mtk_hci/nautilus_3.5_RC/include/local -I$(DMX_ROOT)/drm/mtk_hci/nautilus_3.5_RC/include/src/cmn/include

TZ_ROOT = $(VM_LINUX_ROOT)/target/public/mt53xx_com/tz_secure
TZ_INC = -I$(TZ_ROOT)/open/inc/skb -I$(TZ_ROOT)/open/inc/hci

VDEC_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/vdec_v2
VDEC_INC = -I$(VDEC_ROOT)             \
           -I$(VDEC_ROOT)/h264             \
           -I$(VDEC_ROOT)/mpeg4 \
           -I$(VDEC_ROOT)/mpv        \
           -I$(VDEC_ROOT)/wmv   \
           -I$(VDEC_ROOT)/rv   \
           -I$(VDEC_ROOT)/img \
           -I$(VDEC_ROOT)/avs \
           -I$(VDEC_ROOT)/vp6 \
           -I$(VDEC_ROOT)/vp8 \
           -I$(VDEC_ROOT)/raw

VENC_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/venc
VENC_INC = -I$(VENC_ROOT)          \
           -I$(VENC_ROOT)/h264

TUNER_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/brdcst_if/tuner_src
TUNER_INC = -I$(TUNER_ROOT)/Tuner \
            -I$(TUNER_ROOT)/TunerHAL \
            -I$(TUNER_ROOT)/CtrlBus \
            -I$(TUNER_ROOT)/TunerPool \
            -I$(TUNER_ROOT)/TunerNptv/system \
            -I$(TUNER_ROOT)/inc

ifeq "$(findstring 5890_MT5112EE,$(BRDCST_IF))" "5890_MT5112EE"
TUNER_INC += -I$(TUNER_ROOT)/TunerDTD
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogNA
DEFINES += -DCC_FEDTD
endif
ifeq "$(findstring 5890_MT5135,$(BRDCST_IF))" "5890_MT5135"
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBC
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogEU
DEFINES += -DCC_FEDVBT
DEFINES += -DCC_DVBT_SUPPORT
endif
ifeq "$(findstring 5890DUAL,$(BRDCST_IF))" "5890DUAL"
TUNER_INC += -I$(TUNER_ROOT)/TunerDTD
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogNA
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
TUNER_INC += -I$(TUNER_ROOT)/TunerAnalogEU
DEFINES += -DCC_DVBT_SUPPORT
endif

ifeq "$(findstring 5890DVBTC,$(BRDCST_IF))" "5890DVBTC"
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBC
DEFINES += -DCC_DVBT_SUPPORT
endif

ifeq "$(findstring TC90517,$(BRDCST_IF))" "TC90517"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/TC90517
endif

#$(error DRV_ROOT is $(DRV_ROOT))

ifeq "$(findstring TC90527,$(CUST_DEMOD))" "TC90527"
TUNER_INC += -I$(DRV_ROOT)/3rd_party/LINUX/VDRBRDCST/VDRDemod/TC90527
endif

ifeq "$(findstring MN88471,$(BRDCST_IF))" "MN88471"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/MN88471/
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
endif

ifeq "$(findstring ATBM8848,$(BRDCST_IF))" "ATBM8848"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/ATBM8848
endif

ifeq "$(findstring ATBM8846E,$(BRDCST_IF))" "ATBM8846E"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/ATBM8846E
endif

ifeq "$(findstring CXD2820,$(BRDCST_IF))" "CXD2820"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/CXD2820
TUNER_INC += -I$(TUNER_ROOT)/TunerDVBT
endif
ifeq "$(findstring 8G80,$(BRDCST_IF))" "8G80"
TUNER_INC += -I$(TUNER_ROOT)/Tuner3rdParty/8G80
endif
TUNER_INC += -I$(TUNER_ROOT)/TunerATD/eu
TUNER_INC += -I$(TUNER_ROOT)/TunerATD/common
TUNER_INC += -I$(TUNER_ROOT)/TunerATD/na
NPTV_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/nptv5891
NPTV_INC += -I$(NPTV_ROOT)/inc \
		  -I$(NPTV_ROOT)/inc/hw \
		  -I$(NPTV_ROOT)/inc/drv \
		  -I$(NPTV_ROOT)/inc/sys \
		  -I$(NPTV_ROOT)/drv/tuner/system \
		  -I$(NPTV_ROOT)/inc/empty \
		  -I$(NPTV_ROOT)/inc/tmp

VDP_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/vdp8290
FBM_ROOT = $(DRV_ROOT)/$(DRIVER_DIR)/fbm8290

VDP_INC += -I$(VDP_ROOT)
FBM_INC += -I$(FBM_ROOT)

OSD_INC += -I$(DRV_ROOT)/$(DRIVER_DIR)/osd6896

export DRIVER_INC = $(DRV_INC) $(TARGET_INC) $(OSD_INC) $(AUD_INC) $(VDEC_INC) $(VENC_INC) $(PLAYMGR_INC) $(SWDMX_INC) $(D_CUST_INC) $(PSR_INC) $(OSAI_INC) $(TUNER_INC) $(NPTV_INC) $(VDP_INC) $(DMX_INC) $(TZ_INC) $(FBM_INC)

DEFINES += -D_CPU_LITTLE_ENDIAN_  $(EXTRA_DEFINES) \
                   -DI1394_DRV_ONLY                         \
                   -DCC_SCPOS_EN                            \
                   -DCC_SRM_ON

DEFINES += -DCC_MT5891
DEFINES += -DCC_53XX_SWDMX_V2
ifneq "$(LINUX_SOLUTION)" "true"
DEFINES += -DCC_DRIVER_PROGRAM
DEFINES += -DDEFAULT_PANEL_SELECT=0

ifeq "$(KEY_FROM_DFB)" "y"
DEFINES += -DKEY_FROM_DFB
endif

endif
DEFINES += -Wall -Wno-format

DEFINES += -DMT53XX_OSAI_MODULE -DMT53XX_FB_MODULE
DEFINES += -DCC_DYNAMIC_POWER_ONOFF

ifeq "$(BUILD_CFG)" "debug"
DEFINES += -g -mapcs-frame
else
ifeq "$(BUILD_WITH_DBG_INFO)" "true"
DEFINES += -g -mapcs-frame
endif
DEFINES += -DNDEBUG
endif

OPTIMIZE_LVL ?=
ifneq "$(OPTIMIZE_LVL)" "-O2"
DEFINES += $(OPTIMIZE_LVL)
endif

ifndef WARNING_TO_ERROR
export WARNING_TO_ERROR =true
endif

ifneq "$(shell echo $(WARNING_TO_ERROR) | tr '[:lower:]' '[:upper:]')" "FALSE"
DEFINES += -Werror
endif
DEFINES += -pipe
export ASM_DEFINES = -Wa,--fatal-warnings

export DEFINES			:= $(sort $(DEFINES))

DEFINES += -Wframe-larger-than=4096
