/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: io_mtfe_isdbs.h,v $
 * $Revision: #1 $
 *---------------------------------------------------------------------------*/

/** @file io_mtfe_isdbs.h
 */
#ifndef IO_MTFE_ISDBS_H
#define IO_MTFE_ISDBS_H
//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include "u_handle.h"
#include "pi_isdbs_demod_if.h"

//-----------------------------------------------------------------------------
// Constant definitions
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------
// For lock state machine
typedef enum
{
	MTFE_ISDBS_IDLE_STATE = 0,
	MTFE_ISDBS_CONNECTING_STATE,
	MTFE_ISDBS_LOCK_STATE, 
	MTFE_ISDBS_UNLOCK_STATE, 
	MTFE_ISDBS_STATE_END
} MTFE_ISDBS_LOCK_STATE_ENUM_T;

typedef struct _MTAL_ISDBS_PD_CTX_T
{
    ISDBS_DEMOD_CTX_T*         pDemodCtx;
    HANDLE_T                hHalLock;

    HANDLE_T    t_monitor_thread;//monitor thread
    HANDLE_T    t_escape_mon_suspend; //sema for mointor suspend
    BOOL           fgMonitorThreadRunning;
    BOOL           fgBreakMonitor;
    BOOL           fgAskMoniDoGetSync;
    HANDLE_T    t_MoniCmdMsgQ;
    MTFE_ISDBS_LOCK_STATE_ENUM_T  eState;
    UINT32        u4TotalBit;
    UINT32        u4ErrBit;
} MTAL_ISDBS_PD_CTX_T, *PMTAL_ISDBS_PD_CTX_T;

// For Monitor Message Queue pMTPdCtx->t_MoniMsgQ
typedef enum
{
//	TUNER_ISDBS_CMD_SETFREQ = 0,
//	TUNER_ISDBS_CMD_STARTSEARCH, 
    TUNER_ISDBS_CMD_CONNECT = 1,//don't start from 0
    TUNER_ISDBS_CMD_END
} TUNER_ISDBS_CMD_ENUM_T;

typedef struct
{
    TUNER_ISDBS_CMD_ENUM_T    CmdId;
    UINT32                        u4TickCnt;
    union
    {
        MTFE_ISDBS_PARAMETER_T   ConnectParam;
    } CmdInfo;
} TUNER_ISDBS_CMD_QUEUE_T;

#define TUNER_ISDBS_CMD_QUEUE_SIZE    32
//-----------------------------------------------------------------------------
// Public functions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Macro definitions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Static variables
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Static Functions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Constant definitions
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Private functions
//-----------------------------------------------------------------------------
#endif /*#define IO_MTFE_ISDBS_H*/

