/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: mt53xx_dif.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file dif_mt53xx.h
 *  Define DIF interface.
 */

#ifndef DIF_MT53XX_H
#define DIF_MT53XX_H


#include <x_typedef.h>
#include "mt53xx_dmx.h"
#include "mt53xx_i1394.h"


// IOCTL commands
// IOCTL_INDEX definition for 537x modules
#define DMX_IOCTL_INDEX                     0
#define I1394_IOCTL_INDEX                   100

// DMX IOCTL
#define DMX_IOCTL_TEST                      DMX_IOCTL_INDEX + 0
#define DMX_IOCTL_SET_PID                   DMX_IOCTL_INDEX + 1
#define DMX_IOCTL_GET_PID                   DMX_IOCTL_INDEX + 2
#define DMX_IOCTL_PSI_GET_BUF               DMX_IOCTL_INDEX + 3
#define DMX_IOCTL_PSI_UNLOCK_BUF            DMX_IOCTL_INDEX + 4

// I1394 IOCTL
#define I1394_IOCTL_INIT                    I1394_IOCTL_INDEX + 0
#define I1394_IOCTL_GET_DEVICE_CNT          I1394_IOCTL_INDEX + 1
#define I1394_IOCTL_GET_ALL_DEVICE          I1394_IOCTL_INDEX + 2
#define I1394_IOCTL_GET_DEVICE_STATE        I1394_IOCTL_INDEX + 3
#define I1394_IOCTL_SELECT_DEVICE           I1394_IOCTL_INDEX + 4
#define I1394_IOCTL_SET_ISO_CH_CTRL         I1394_IOCTL_INDEX + 5
#define I1394_IOCTL_SET_DEVICE_FORMAT       I1394_IOCTL_INDEX + 6
#define I1394_IOCTL_SET_DEVICE_CTRL         I1394_IOCTL_INDEX + 7


#endif  // DIF_MT53XX_H
