/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: mt53xx_dmx.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file dmx_mt53xx.h
 *  Define DMX interface.
 */

#ifndef DMX_MT53XX_H
#define DMX_MT53XX_H

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------

#include <x_typedef.h>

//-----------------------------------------------------------------------------
// Configurations
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Constant definitions
//-----------------------------------------------------------------------------

#define DMX_DEVICE                          "/dev/dif"
#define DMX_MAX_PSI_COPY_SIZE               0x20000


/*
/// Function bitmap of PID operations
#define DMX_PID_FLAG_VALID                  0x00000001
#define DMX_PID_FLAG_TS_INDEX               0x00000002
#define DMX_PID_FLAG_PID                    0x00000004
#define DMX_PID_FLAG_PCR                    0x00000008
#define DMX_PID_FLAG_BUFFER                 0x00000010
#define DMX_PID_FLAG_STEER                  0x00000020
#define DMX_PID_FLAG_DESC_MODE              0x00000040
#define DMX_PID_FLAG_DEVICE_ID              0x00000080
#define DMX_PID_FLAG_CALLBACK               0x00000100
#define DMX_PID_FLAG_KEY_INDEX              0x00000200
#define DMX_PID_FLAG_DATA_POINTERS          0x00000400
#define DMX_PID_FLAG_NONE                   0
#define DMX_PID_FLAG_ALL                    0xffffffff
*/

//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------

/// Structure of test command
typedef struct
{
    UINT32 u4Data;
} DMX_IOCTL_TEST_T;

/*
typedef struct
{
    BOOL fgEnable;                  // Enable or disable
    BOOL fgAllocateBuffer;          // Allocate buffer
    UINT8 u1TsIndex;                // TS index
    UINT8 u1DeviceId;               // Device ID
    UINT8 u1KeyIndex;               // Descramble key index
    UINT8 u1SteerMode;              // Steering mode
    UINT16 u2Pid;                   // PID
    UINT32 u4BufAddr;               // Buffer address
    UINT32 u4BufSize;               // Buffer size
    UINT32 u4Rp;                    // Read pointer
    UINT32 u4Wp;                    // Write pointer
    DMX_PCR_MODE_T ePcrMode;        // PCR mode
    DMX_PID_TYPE_T ePidType;        // PID type
    DMX_DESC_MODE_T eDescMode;      // Descramble mode
    PFN_DMX_NOTIFY pfnNotify;       // Callback function
    void* pvNotifyTag;              // Tag value of callback function
} DMX_IOCTL_PID_T;
*/

/// Structure of get buffer command
typedef struct
{
    UINT8 u1Pidx;
    UINT32 u4FrameAddr;
    UINT32 u4SkipSize;
    UINT32 u4CopySize;
    UINT8* pu1Buf;
    UINT8 u1SerialNumber;
} DMX_IOCTL_PSI_GET_T;

/// Structure of unlock buffer command
typedef struct
{
    UINT8 u1Pidx;
    UINT32 u4Size;
    UINT32 u4FrameAddr;
    UINT8 u1SerialNumber;
} DMX_IOCTL_PSI_UNLOCK_T;


//-----------------------------------------------------------------------------
// Macro definitions
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Prototypes of public functions
//-----------------------------------------------------------------------------


#endif  // DMX_MT53XX_H

