/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef IONODES_H
#define IONODES_H


#include <linux/device.h>


#define IO_NODE_MAJOR_PAPI      240

/* major 241 devices */
#define IO_NODE_MAJOR_CLI       241
#define IO_NODE_MAJOR_MTAL      241
#define IO_NODE_MAJOR_CB        241
#define IO_NODE_MAJOR_GPIO      241
#define IO_NODE_MAJOR_DDI       242

/* major 241 devices' minor number */
#define IO_NODE_MINOR_MTAL        0
#define IO_NODE_MINOR_CLI         4
#define IO_NODE_MINOR_CB          8
#define IO_NODE_MINOR_GPIO       12
#define IO_NODE_MINOR_NATIVE_CB  16

#define IO_NODE_MAJOR_JPG       251
#define IO_NODE_MAJOR_SDAL      250
#define IO_NODE_MAJOR_IR        249
#define IO_NODE_MAJOR_FEEDER    247
#define IO_NODE_MAJOR_EEP       246
#define IO_NODE_MAJOR_TSREC     245
#define IO_NODE_MAJOR_MPEG      239

#define IO_NODE_MAJOR_KMEM      244
#define IO_NODE_MAJOR_VOMX      238
#define IO_NODE_MINOR_FBMOMX      0
#define IO_NODE_MINOR_ORGOMX      4
#define IO_NODE_MINOR_VDECOMX     8
#define IO_NODE_MINOR_VENCOMX    12
#define IO_NODE_MINOR_VDPOMX     16

#define IO_NODE_MAJOR_AOMX      237

#define IO_NODE_MAJOR_PVR       236
#define IO_NODE_MAJOR_B2R       243

#define IO_NODE_MAJOR_FBM       251
#define IO_NODE_MINOR_FBM       64
#define IO_NODE_NUMBER_FBM      128
#define IO_NODE_MAJOR_B2R       243

#define DEV_SDAL                "sdal"
#define DEV_CLI                 "cli"
#define DEV_CB                  "cb"
#define DEV_GPIO                "gpio"
#define DEV_JPG                 "jpg"
#define DEV_FEEDER              "feeder"
#define DEV_EEP                 "mtk_eep"
#define DEV_TSREC               "tsrec"
#define DEV_FBM                 "fbm"
#define DEV_PVR                 "pvr"
#define DEV_MPEG                "mpeg"

#define DEV_KMEM                "kmem2"
#define DEV_VOMX                "vomx"
#define DEV_VDECOMX             "vdecomx"
#define DEV_VENCOMX             "vencomx"
#define DEV_FBMOMX              "fbmomx"
#define DEV_VDPOMX              "vdpomx"
#define DEV_AOMX                "aomx"
#define DEV_ADECOMX             "adecomx"

#define DEV_B2R                 "b2r"

#define DEV_PAPI                "papi"
#define DEV_MTAL                "mtal"
#define DEV_DDI                 "ddi"

typedef struct
{
	unsigned int            major;
	unsigned int            minor;
	unsigned int            numbers;
	char                    *name;
	umode_t                 mode;
	struct file_operations  *fops;
} DEVLIST_T;

#endif //IONODES_H
